<!-- This comment will put IE 6, 7 and 8 in quirks mode -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>The m17n Library: Font</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javaScript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body onload='searchBox.OnSelectItem(0);'>
<!-- Generated by Doxygen 1.6.3 -->
<script type="text/javascript"><!--
var searchBox = new SearchBox("searchBox", "search",false,'Search');
--></script>
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <img id="MSearchSelect" src="search/search.png"
             onmouseover="return searchBox.OnSearchSelectShow()"
             onmouseout="return searchBox.OnSearchSelectHide()"
             alt=""/>
        <input type="text" id="MSearchField" value="Search" accesskey="S"
             onfocus="searchBox.OnSearchFieldFocus(true)" 
             onblur="searchBox.OnSearchFieldFocus(false)" 
             onkeyup="searchBox.OnSearchFieldChange(event)"/>
        <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
        </div>
      </li>
    </ul>
  </div>
</div>
<div class="contents">
<h1>Font<br/>
<small>
[<a class="el" href="group__m17nGUI.html">GUI API</a>]</small>
</h1>
<p>Font object.  
<a href="#_details">More...</a></p>
<table border="0" cellpadding="0" cellspacing="0">
<tr><td colspan="2"><h2>Typedefs</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef struct <a class="el" href="group__m17nFont.html#gace14a93b58bd3cd143f267101f805b9d">MFont</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nFont.html#gace14a93b58bd3cd143f267101f805b9d">MFont</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Type of fonts.  <a href="#gace14a93b58bd3cd143f267101f805b9d"></a><br/></td></tr>
<tr><td colspan="2"><h2>Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nFont.html#gace14a93b58bd3cd143f267101f805b9d">MFont</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nFont.html#gaefd3aca05f30fe665fe47854012688e7">mfont</a> ()</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Create a new font.  <a href="#gaefd3aca05f30fe665fe47854012688e7"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nFont.html#gace14a93b58bd3cd143f267101f805b9d">MFont</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nFont.html#ga370ca70e1fc0782bda4c47b77b17d4c6">mfont_parse_name</a> (const char *name, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> format)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Create a font by parsing a fontname.  <a href="#ga370ca70e1fc0782bda4c47b77b17d4c6"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">char *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nFont.html#ga10b60c3a89c89494f2129941c28eeca2">mfont_unparse_name</a> (<a class="el" href="group__m17nFont.html#gace14a93b58bd3cd143f267101f805b9d">MFont</a> *font, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> format)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Create a fontname from a font.  <a href="#ga10b60c3a89c89494f2129941c28eeca2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nFont.html#gace14a93b58bd3cd143f267101f805b9d">MFont</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nFont.html#ga9c27528cb4a68b6c7f845ef2b98b0f3c">mfont_copy</a> (<a class="el" href="group__m17nFont.html#gace14a93b58bd3cd143f267101f805b9d">MFont</a> *font)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Make a copy of a font.  <a href="#ga9c27528cb4a68b6c7f845ef2b98b0f3c"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nFont.html#gad4d783b9329404d63cfdf43bbd247911">mfont_get_prop</a> (<a class="el" href="group__m17nFont.html#gace14a93b58bd3cd143f267101f805b9d">MFont</a> *font, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> key)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get a property value of a font.  <a href="#gad4d783b9329404d63cfdf43bbd247911"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nFont.html#ga2104516081a823784c1b56dcb3011237">mfont_put_prop</a> (<a class="el" href="group__m17nFont.html#gace14a93b58bd3cd143f267101f805b9d">MFont</a> *font, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> key, void *val)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Put a property value to a font.  <a href="#ga2104516081a823784c1b56dcb3011237"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nFont.html#gaf8c26835d0c41a0f63f2ad1e09b2cb88">mfont_selection_priority</a> ()</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Return the font selection priority.  <a href="#gaf8c26835d0c41a0f63f2ad1e09b2cb88"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nFont.html#gacc9d2fab3fd8c4a2ddce5cf478d86229">mfont_set_selection_priority</a> (<a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> *keys)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Set the font selection priority.  <a href="#gacc9d2fab3fd8c4a2ddce5cf478d86229"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nFont.html#gace14a93b58bd3cd143f267101f805b9d">MFont</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nFont.html#ga33ec3560c126987a5a63130737849ea2">mfont_find</a> (<a class="el" href="group__m17nFrame.html#gabb36d3a69526a891ce7534bda63a2687">MFrame</a> *frame, <a class="el" href="group__m17nFont.html#gace14a93b58bd3cd143f267101f805b9d">MFont</a> *spec, int *score, int max_size)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Find a font.  <a href="#ga33ec3560c126987a5a63130737849ea2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nFont.html#gace78101b0ce5a51b3d6058ce4c0f2b82">mfont_set_encoding</a> (<a class="el" href="group__m17nFont.html#gace14a93b58bd3cd143f267101f805b9d">MFont</a> *font, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> encoding_name, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> repertory_name)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Set encoding of a font.  <a href="#gace78101b0ce5a51b3d6058ce4c0f2b82"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">char *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nFont.html#gaa042ce71ba7811ef9374fd2a58e23e7f">mfont_name</a> (<a class="el" href="group__m17nFont.html#gace14a93b58bd3cd143f267101f805b9d">MFont</a> *font)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Create a fontname from a font.  <a href="#gaa042ce71ba7811ef9374fd2a58e23e7f"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nFont.html#gace14a93b58bd3cd143f267101f805b9d">MFont</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nFont.html#ga9ac6f64a37fd3b6d59a1d7ffd675dc7e">mfont_from_name</a> (const char *name)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Create a new font from fontname.  <a href="#ga9ac6f64a37fd3b6d59a1d7ffd675dc7e"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nFont.html#ga50dc0617125f859540f03f1efd8aaa14">mfont_resize_ratio</a> (<a class="el" href="group__m17nFont.html#gace14a93b58bd3cd143f267101f805b9d">MFont</a> *font)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get resize information of a font.  <a href="#ga50dc0617125f859540f03f1efd8aaa14"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nFont.html#ga48ecb15f6d6ea751c32b7bd2802197e0">mfont_list</a> (<a class="el" href="group__m17nFrame.html#gabb36d3a69526a891ce7534bda63a2687">MFrame</a> *frame, <a class="el" href="group__m17nFont.html#gace14a93b58bd3cd143f267101f805b9d">MFont</a> *font, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> language, int maxnum)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get a list of fonts.  <a href="#ga48ecb15f6d6ea751c32b7bd2802197e0"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nFont.html#ga7de45bffe64304ddddfe29f6c1a209f6">mfont_list_family_names</a> (<a class="el" href="group__m17nFrame.html#gabb36d3a69526a891ce7534bda63a2687">MFrame</a> *frame)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get a list of font famiy names.  <a href="#ga7de45bffe64304ddddfe29f6c1a209f6"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nFont.html#gac579c026f0165e5b9b9a255995162f35">mfont_check</a> (<a class="el" href="group__m17nFrame.html#gabb36d3a69526a891ce7534bda63a2687">MFrame</a> *frame, <a class="el" href="m17n-gui_8h.html#a4c949033ca30d88fb8775caeb4134a1b">MFontset</a> *fontset, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> script, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> language, <a class="el" href="group__m17nFont.html#gace14a93b58bd3cd143f267101f805b9d">MFont</a> *font)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Check the usability of a font.  <a href="#gac579c026f0165e5b9b9a255995162f35"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nFont.html#ga33a65ab6f61909ba85dd93ee43835f0a">mfont_match_p</a> (<a class="el" href="group__m17nFont.html#gace14a93b58bd3cd143f267101f805b9d">MFont</a> *font, <a class="el" href="group__m17nFont.html#gace14a93b58bd3cd143f267101f805b9d">MFont</a> *spec)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Check is a font matches with a font spec.  <a href="#ga33a65ab6f61909ba85dd93ee43835f0a"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nFont.html#gace14a93b58bd3cd143f267101f805b9d">MFont</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nFont.html#ga209b13afe6907de28d1fad619ad354d7">mfont_open</a> (<a class="el" href="group__m17nFrame.html#gabb36d3a69526a891ce7534bda63a2687">MFrame</a> *frame, <a class="el" href="group__m17nFont.html#gace14a93b58bd3cd143f267101f805b9d">MFont</a> *font)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Open a font.  <a href="#ga209b13afe6907de28d1fad619ad354d7"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nFont.html#gace14a93b58bd3cd143f267101f805b9d">MFont</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nFont.html#ga35748de25dce8fe94e765d913d7f674a">mfont_encapsulate</a> (<a class="el" href="group__m17nFrame.html#gabb36d3a69526a891ce7534bda63a2687">MFrame</a> *frame, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> data_type, void *data)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Encapusulate a font.  <a href="#ga35748de25dce8fe94e765d913d7f674a"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nFont.html#ga52df122a9924755823427845652d1306">mfont_close</a> (<a class="el" href="group__m17nFont.html#gace14a93b58bd3cd143f267101f805b9d">MFont</a> *font)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Close a font.  <a href="#ga52df122a9924755823427845652d1306"></a><br/></td></tr>
<tr><td colspan="2"><h2>Variables</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nFont.html#ga0cc7b165764f76eebb58583b06220e8a">mfont_freetype_path</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">List of font files and directories that contain font files.  <a href="#ga0cc7b165764f76eebb58583b06220e8a"></a><br/></td></tr>
<tr><td colspan="2"><h2>Variables: Keys of font property.</h2></td></tr>
<tr><td colspan="2"><p><a class="anchor" id="amgrpbe8fc97543de56bd250933f8edafec95"></a> </p>
<br/><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nFont.html#gaaf47ff596e3d9768b214a039014b6ea5">Mfoundry</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Key of font property specifying foundry.  <a href="#gaaf47ff596e3d9768b214a039014b6ea5"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nFont.html#gab297101760f7573ab33b846ccbda7500">Mfamily</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Key of font property specifying family.  <a href="#gab297101760f7573ab33b846ccbda7500"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nFont.html#ga748212149a23eda2e6225ed121305308">Mweight</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Key of font property specifying weight.  <a href="#ga748212149a23eda2e6225ed121305308"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nFont.html#ga4a3a457f1c52fb783809b94366a34d86">Mstyle</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Key of font property specifying style.  <a href="#ga4a3a457f1c52fb783809b94366a34d86"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nFont.html#ga9016e01983ec22fc8e1255629e337b07">Mstretch</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Key of font property specifying stretch.  <a href="#ga9016e01983ec22fc8e1255629e337b07"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nFont.html#ga00bea74da7de4bf0b94de59f6b44d1e9">Madstyle</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Key of font property specifying additional style.  <a href="#ga00bea74da7de4bf0b94de59f6b44d1e9"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nFont.html#gad72f8b1c8e8eca761d4bfbc7abb56e25">Mspacing</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Key of font property specifying spacing.  <a href="#gad72f8b1c8e8eca761d4bfbc7abb56e25"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nFont.html#gab8c5e8d3685a530e2ae45f3b8a21ae76">Mregistry</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Key of font property specifying registry.  <a href="#gab8c5e8d3685a530e2ae45f3b8a21ae76"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nFont.html#ga072ce0799f7766597e4d3028b70fef60">Msize</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Key of font property specifying size.  <a href="#ga072ce0799f7766597e4d3028b70fef60"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nFont.html#ga8a615da3d1be5e23ca2d4cc02496dc97">Motf</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Key of font property specifying file name.  <a href="#ga8a615da3d1be5e23ca2d4cc02496dc97"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nFont.html#gacfad1cf7295887580fb3d96fc5e7bf4c">Mfontfile</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Key of font property specifying file name.  <a href="#gacfad1cf7295887580fb3d96fc5e7bf4c"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nFont.html#gab4a821ee20cc5855371b31a4a0749c06">Mresolution</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Key of font property specifying resolution.  <a href="#gab4a821ee20cc5855371b31a4a0749c06"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nFont.html#ga99d4189483ab20c0c91de2693c62f073">Mmax_advance</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Key of font property specifying max advance width.  <a href="#ga99d4189483ab20c0c91de2693c62f073"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nFont.html#gae72b66ecbfdf5a117614f76b694c5a34">Mfontconfig</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Symbol of name "fontconfig".  <a href="#gae72b66ecbfdf5a117614f76b694c5a34"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nFont.html#ga61aefaf21f63323506a84efa8dae6ded">Mx</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Symbol of name "x".  <a href="#ga61aefaf21f63323506a84efa8dae6ded"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nFont.html#ga49214e506ef5cecc1e0ef233f22e5491">Mfreetype</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Symbol of name "freetype".  <a href="#ga49214e506ef5cecc1e0ef233f22e5491"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nFont.html#gaaf3238f7c80f54f971f8a5506d90c97a">Mxft</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Symbol of name "xft".  <a href="#gaaf3238f7c80f54f971f8a5506d90c97a"></a><br/></td></tr>
</table>
<hr/><a name="_details"></a><h2>Detailed Description</h2>
<p>Font object. </p>
<p>The m17n GUI API represents a font by an object of the type <code>MFont</code>. A font can have <em>font</em> <em>properties</em>. Like other types of properties, a font property consists of a key and a value. The key of a font property must be one of the following symbols:</p>
<p><code>Mfoundry</code>, <code>Mfamily</code>, <code>Mweight</code>, <code>Mstyle</code>, <code>Mstretch</code>, <code>Madstyle</code>, <code>Mregistry</code>, <code>Msize</code>, <code>Mresolution</code>, <code>Mspacing</code>.</p>
<p>When the key of a font property is <code>Msize</code> or <code>Mresolution</code>, its value is an integer. Otherwise the value is a symbol.</p>
<p>The notation "xxx property of F" means the font property that belongs to font F and whose key is <code>Mxxx</code>.</p>
<p>The value of a foundry property is a symbol representing font foundry information, e.g. adobe, misc, etc.</p>
<p>The value of a family property is a symbol representing font family information, e.g. times, helvetica, etc.</p>
<p>The value of a weight property is a symbol representing weight information, e.g. normal, bold, etc.</p>
<p>The value of a style property is a symbol representing slant information, e.g. normal, italic, etc.</p>
<p>The value of a stretch property is a symbol representing width information, e.g. normal, semicondensed, etc.</p>
<p>The value of an adstyle property is a symbol representing abstract font family information, e.g. serif, sans-serif, etc.</p>
<p>The value of a registry property is a symbol representing registry information, e.g. iso10646-1, iso8895-1, etc.</p>
<p>The value of a size property is an integer representing design size in the unit of 1/10 point.</p>
<p>The value of a resolution property is an integer representing assumed device resolution in the unit of dots per inch (dpi).</p>
<p>The value of a type property is a symbol indicating a font driver; currently Mx or Mfreetype.</p>
<p>The m17n library uses font objects for two purposes: to receive font specification from an application program, and to present available fonts to an application program. When the m17n library presents an available font to an application program, all font properties have a concrete value.</p>
<p>The m17n library supports three kinds of fonts: Window system fonts, FreeType fonts, and OpenType fonts.</p>
<ul>
<li>
<p class="startli">Window system fonts</p>
<p>The m17n-X library supports all fonts handled by an X server and an X font server. The correspondence between XLFD fields and font properties are shown below.</p>
<div class="fragment"><pre class="fragment">
    XLFD field                                  property
    ---------------                             --------
    FOUNDRY                                     foundry
    FAMILY_NAME                                 family
    WEIGHT_NAME                                 weight
    SLANT                                       style
    SETWIDTH_NAME                               stretch
    ADD_STYLE_NAME                              adstyle
    PIXEL_SIZE                                  size
    RESOLUTION_Y                                resolution
    CHARSET_REGISTRY-CHARSET_ENCODING           registry
</pre></div><p>XLFD fields not listed in the above table are ignored.</p>
<p class="endli"></p>
</li>
<li>
<p class="startli">FreeType fonts</p>
<p>The m17n library, if configured to use the FreeType library, supports all fonts that can be handled by the FreeType library. The variable <a class="el" href="group__m17nFont.html#ga0cc7b165764f76eebb58583b06220e8a" title="List of font files and directories that contain font files.">mfont_freetype_path</a> is initialized properly according to the configuration of the m17n library and the environment variable <code>M17NDIR</code>. See the documentation of the variable for details.</p>
<p>If the m17n library is configured to use the fontconfig library, in addition to <a class="el" href="group__m17nFont.html#ga0cc7b165764f76eebb58583b06220e8a" title="List of font files and directories that contain font files.">mfont_freetype_path</a>, all fonts available via fontconfig are supported.</p>
<p>The family name of a FreeType font corresponds to the family property. Style names of FreeType fonts correspond to the weight, style, and stretch properties as below.</p>
<div class="fragment"><pre class="fragment">
    style name          weight  style   stretch
    ----------          ------  -----   -------
    Regular             medium  r       normal
    Italic              medium  i       normal
    Bold                bold    r       normal
    Bold Italic         bold    i       normal
    Narrow              medium  r       condensed
    Narrow Italic       medium  i       condensed
    Narrow Bold         bold    r       condensed
    Narrow Bold Italic  bold    i       condensed
    Black               black   r       normal
    Black Italic        black   i       normal
    Oblique             medium  o       normal
    BoldOblique         bold    o       normal
</pre></div><p>Style names not listed in the above table are treated as "Regular".</p>
<p>Combination of a platform ID and an encoding ID corresponds to the registry property. For example, if a font has the combination (1 1), the registry property is 1-1. Some frequent combinations have a predefined registry property as below.</p>
<div class="fragment"><pre class="fragment">
    platform ID         encoding ID     registry property
    -----------         -----------     -----------------
    0                   3               unicode-bmp
    0                   4               unicode-full
    1                   0               apple-roman
    3                   1               unicode-bmp
    3                   1               unicode-full
</pre></div><p>Thus, a font that has two combinations (1 0) and (3 1) corresponds to four font objects whose registries are 1-0, apple-roman, 3-1, and unicode-bmp.</p>
<p class="endli"></p>
</li>
<li>
<p class="startli">OpenType fonts</p>
<p>The m17n library, if configured to use both the FreeType library and the OTF library, supports any OpenType fonts. The list of actually available fonts is created in the same way as in the case of FreeType fonts. If a fontset instructs to use an OpenType font via an FLT (Font Layout Table), and the FLT has an OTF-related command (e.g. otf:deva), the OTF library converts a character sequence to a glyph code sequence according to the OpenType layout tables of the font, and the FreeType library gives a bitmap image for each glyph.</p>
<p class="endli"></p>
</li>
</ul>
<hr/><h2>Typedef Documentation</h2>
<a class="anchor" id="gace14a93b58bd3cd143f267101f805b9d"></a><!-- doxytag: member="m17n&#45;gui.h::MFont" ref="gace14a93b58bd3cd143f267101f805b9d" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef struct <a class="el" href="group__m17nFont.html#gace14a93b58bd3cd143f267101f805b9d">MFont</a> <a class="el" href="group__m17nFont.html#gace14a93b58bd3cd143f267101f805b9d">MFont</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Type of fonts. </p>
<p>The type <a class="el" href="group__m17nFont.html#gace14a93b58bd3cd143f267101f805b9d" title="Type of fonts.">MFont</a> is the structure defining fonts. It contains information about the following properties of a font: foundry, family, weight, style, stretch, adstyle, registry, size, and resolution.</p>
<p>This structure is used both for specifying a font in a fontset and for storing information about available system fonts.</p>
<p>The internal structure is concealed from an application program.</p>
<dl class="user"><dt><b>See Also:</b></dt><dd><a class="el" href="group__m17nFont.html#gaefd3aca05f30fe665fe47854012688e7" title="Create a new font.">mfont()</a>, <a class="el" href="group__m17nFont.html#ga9ac6f64a37fd3b6d59a1d7ffd675dc7e" title="Create a new font from fontname.">mfont_from_name()</a>, <a class="el" href="group__m17nFont.html#ga33ec3560c126987a5a63130737849ea2" title="Find a font.">mfont_find()</a>. </dd></dl>

</div>
</div>
<hr/><h2>Function Documentation</h2>
<a class="anchor" id="gaefd3aca05f30fe665fe47854012688e7"></a><!-- doxytag: member="font.c::mfont" ref="gaefd3aca05f30fe665fe47854012688e7" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nFont.html#gace14a93b58bd3cd143f267101f805b9d">MFont</a>* mfont </td>
          <td>(</td>
          <td class="paramname"></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Create a new font. </p>
<p>The <a class="el" href="group__m17nFont.html#gaefd3aca05f30fe665fe47854012688e7" title="Create a new font.">mfont()</a> function creates a new font object that has no property.</p>
<dl class="user"><dt><b>Return value:</b></dt><dd>This function returns a pointer to the created font object. </dd></dl>

</div>
</div>
<a class="anchor" id="ga370ca70e1fc0782bda4c47b77b17d4c6"></a><!-- doxytag: member="font.c::mfont_parse_name" ref="ga370ca70e1fc0782bda4c47b77b17d4c6" args="(const char *name, MSymbol format)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nFont.html#gace14a93b58bd3cd143f267101f805b9d">MFont</a>* mfont_parse_name </td>
          <td>(</td>
          <td class="paramtype">const char *&nbsp;</td>
          <td class="paramname"> <em>name</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>format</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Create a font by parsing a fontname. </p>
<p>The <a class="el" href="group__m17nFont.html#ga370ca70e1fc0782bda4c47b77b17d4c6" title="Create a font by parsing a fontname.">mfont_parse_name()</a> function creates a new font object. The properties are extracted fontname <b>name</b>.</p>
<p><b>format</b> specifies the format of <b>name</b>. If <b>format</b> is <a class="el" href="group__m17nFont.html#ga61aefaf21f63323506a84efa8dae6ded" title="Symbol of name &quot;x&quot;.">Mx</a>, <b>name</b> is parsed as XLFD (X Logical Font Description). If <b>format</b> is <a class="el" href="group__m17nFont.html#gae72b66ecbfdf5a117614f76b694c5a34" title="Symbol of name &quot;fontconfig&quot;.">Mfontconfig</a>, <b>name</b> is parsed as Fontconfig's textual representation of font. If <b>format</b> is <a class="el" href="group__m17nSymbol.html#ga0346fc05efcccc8f11271b51c0fe3eeb" title="Symbol whose name is &quot;nil&quot;.">Mnil</a>, <b>name</b> is at first parsed as XLFD, and it it fails, parsed as Fontconfig's representation.</p>
<dl class="user"><dt><b>Return value:</b></dt><dd>If the operation was successful, this function returns a pointer to the created font. Otherwise it returns <code>NULL</code>. </dd></dl>

</div>
</div>
<a class="anchor" id="ga10b60c3a89c89494f2129941c28eeca2"></a><!-- doxytag: member="font.c::mfont_unparse_name" ref="ga10b60c3a89c89494f2129941c28eeca2" args="(MFont *font, MSymbol format)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">char* mfont_unparse_name </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nFont.html#gace14a93b58bd3cd143f267101f805b9d">MFont</a> *&nbsp;</td>
          <td class="paramname"> <em>font</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>format</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Create a fontname from a font. </p>
<p>The <a class="el" href="group__m17nFont.html#ga10b60c3a89c89494f2129941c28eeca2" title="Create a fontname from a font.">mfont_unparse_name()</a> function creates a fontname string from font <b>font</b> according to <b>format</b>.</p>
<p><b>format</b> must be <a class="el" href="group__m17nFont.html#ga61aefaf21f63323506a84efa8dae6ded" title="Symbol of name &quot;x&quot;.">Mx</a> or <a class="el" href="group__m17nFont.html#gae72b66ecbfdf5a117614f76b694c5a34" title="Symbol of name &quot;fontconfig&quot;.">Mfontconfig</a>. If it is <a class="el" href="group__m17nFont.html#ga61aefaf21f63323506a84efa8dae6ded" title="Symbol of name &quot;x&quot;.">Mx</a>, the fontname is in XLFD (X Logical Font Description) format. If it is <a class="el" href="group__m17nFont.html#gae72b66ecbfdf5a117614f76b694c5a34" title="Symbol of name &quot;fontconfig&quot;.">Mfontconfig</a>, the fontname is in the style of Fontconfig's text representation.</p>
<dl class="user"><dt><b>Return value:</b></dt><dd>This function returns a newly allocated fontname string, which is not freed unless the user explicitly does so by free(). </dd></dl>

</div>
</div>
<a class="anchor" id="ga9c27528cb4a68b6c7f845ef2b98b0f3c"></a><!-- doxytag: member="font.c::mfont_copy" ref="ga9c27528cb4a68b6c7f845ef2b98b0f3c" args="(MFont *font)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nFont.html#gace14a93b58bd3cd143f267101f805b9d">MFont</a>* mfont_copy </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nFont.html#gace14a93b58bd3cd143f267101f805b9d">MFont</a> *&nbsp;</td>
          <td class="paramname"> <em>font</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Make a copy of a font. </p>
<p>The <a class="el" href="group__m17nFont.html#ga9c27528cb4a68b6c7f845ef2b98b0f3c" title="Make a copy of a font.">mfont_copy()</a> function returns a new copy of font <b>font</b>. </p>

</div>
</div>
<a class="anchor" id="gad4d783b9329404d63cfdf43bbd247911"></a><!-- doxytag: member="font.c::mfont_get_prop" ref="gad4d783b9329404d63cfdf43bbd247911" args="(MFont *font, MSymbol key)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void* mfont_get_prop </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nFont.html#gace14a93b58bd3cd143f267101f805b9d">MFont</a> *&nbsp;</td>
          <td class="paramname"> <em>font</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>key</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get a property value of a font. </p>
<p>The <a class="el" href="group__m17nFont.html#gad4d783b9329404d63cfdf43bbd247911" title="Get a property value of a font.">mfont_get_prop()</a> function gets the value of <b>key</b> property of font <b>font</b>. <b>key</b> must be one of the following symbols:</p>
<p><code>Mfoundry</code>, <code>Mfamily</code>, <code>Mweight</code>, <code>Mstyle</code>, <code>Mstretch</code>, <code>Madstyle</code>, <code>Mregistry</code>, <code>Msize</code>, <code>Mresolution</code>, <code>Mspacing</code>.</p>
<p>If <b>font</b> is a return value of <a class="el" href="group__m17nFont.html#ga33ec3560c126987a5a63130737849ea2" title="Find a font.">mfont_find()</a>, <b>key</b> can also be one of the following symbols:</p>
<p><b>Mfont_ascent</b>, <b>Mfont_descent</b>, <a class="el" href="group__m17nFont.html#ga99d4189483ab20c0c91de2693c62f073" title="Key of font property specifying max advance width.">Mmax_advance</a>.</p>
<dl class="user"><dt><b>Return value: </b></dt><dd>If <b>key</b> is <code>Mfoundry</code>, <code>Mfamily</code>, <code>Mweight</code>, <code>Mstyle</code>, <code>Mstretch</code>, <code>Madstyle</code>, <code>Mregistry</code>, or <code>Mspacing</code>, this function returns the corresponding value as a symbol. If the font does not have <b>key</b> property, it returns <code>Mnil</code>. If <b>key</b> is <code>Msize</code>, <code>Mresolution</code>, <b>Mfont_ascent</b>, Mfont_descent, or <a class="el" href="group__m17nFont.html#ga99d4189483ab20c0c91de2693c62f073" title="Key of font property specifying max advance width.">Mmax_advance</a>, this function returns the corresponding value as an integer. If the font does not have <b>key</b> property, it returns 0. If <b>key</b> is something else, it returns <code>NULL</code> and assigns an error code to the external variable <a class="el" href="group__m17nError.html#ga995a2e373cfd6a8e5eaca8686b5b0a73" title="External variable to hold error code of the m17n library.">merror_code</a>. </dd></dl>

</div>
</div>
<a class="anchor" id="ga2104516081a823784c1b56dcb3011237"></a><!-- doxytag: member="font.c::mfont_put_prop" ref="ga2104516081a823784c1b56dcb3011237" args="(MFont *font, MSymbol key, void *val)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int mfont_put_prop </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nFont.html#gace14a93b58bd3cd143f267101f805b9d">MFont</a> *&nbsp;</td>
          <td class="paramname"> <em>font</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>key</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&nbsp;</td>
          <td class="paramname"> <em>val</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Put a property value to a font. </p>
<p>The <a class="el" href="group__m17nFont.html#ga2104516081a823784c1b56dcb3011237" title="Put a property value to a font.">mfont_put_prop()</a> function puts a font property whose key is <b>key</b> and value is <b>val</b> to font <b>font</b>. <b>key</b> must be one of the following symbols:</p>
<p><code>Mfoundry</code>, <code>Mfamily</code>, <code>Mweight</code>, <code>Mstyle</code>, <code>Mstretch</code>, <code>Madstyle</code>, <code>Mregistry</code>, <code>Msize</code>, <code>Mresolution</code>.</p>
<p>If <b>key</b> is <code>Msize</code> or <code>Mresolution</code>, <b>val</b> must be an integer. Otherwise, <b>val</b> must be a symbol of a property value name. But, if the name is "nil", a symbol of name "Nil" must be specified. </p>

</div>
</div>
<a class="anchor" id="gaf8c26835d0c41a0f63f2ad1e09b2cb88"></a><!-- doxytag: member="font.c::mfont_selection_priority" ref="gaf8c26835d0c41a0f63f2ad1e09b2cb88" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>* mfont_selection_priority </td>
          <td>(</td>
          <td class="paramname"></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Return the font selection priority. </p>
<p>The <a class="el" href="group__m17nFont.html#gaf8c26835d0c41a0f63f2ad1e09b2cb88" title="Return the font selection priority.">mfont_selection_priority()</a> function returns a newly created array of six symbols. The elements are the following keys of font properties ordered by priority.</p>
<p><code>Mfamily</code>, <code>Mweight</code>, <code>Mstyle</code>, <code>Mstretch</code>, <code>Madstyle</code>, <code>Msize</code>.</p>
<p>The m17n library selects the best matching font according to the order of this array. A font that has a different value for a property of lower priority is preferred to a font that has a different value for a property of higher priority. </p>

</div>
</div>
<a class="anchor" id="gacc9d2fab3fd8c4a2ddce5cf478d86229"></a><!-- doxytag: member="font.c::mfont_set_selection_priority" ref="gacc9d2fab3fd8c4a2ddce5cf478d86229" args="(MSymbol *keys)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int mfont_set_selection_priority </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> *&nbsp;</td>
          <td class="paramname"> <em>keys</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Set the font selection priority. </p>
<p>The <a class="el" href="group__m17nFont.html#gacc9d2fab3fd8c4a2ddce5cf478d86229" title="Set the font selection priority.">mfont_set_selection_priority()</a> function sets font selection priority according to <b>keys</b>, which is an array of six symbols. Each element must be one of the below. No two elements must be the same.</p>
<p><code>Mfamily</code>, <code>Mweight</code>, <code>Mstyle</code>, <code>Mstretch</code>, <code>Madstyle</code>, <code>Msize</code>.</p>
<p>See the documentation of the function <a class="el" href="group__m17nFont.html#gaf8c26835d0c41a0f63f2ad1e09b2cb88" title="Return the font selection priority.">mfont_selection_priority()</a> for details. </p>

</div>
</div>
<a class="anchor" id="ga33ec3560c126987a5a63130737849ea2"></a><!-- doxytag: member="font.c::mfont_find" ref="ga33ec3560c126987a5a63130737849ea2" args="(MFrame *frame, MFont *spec, int *score, int max_size)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nFont.html#gace14a93b58bd3cd143f267101f805b9d">MFont</a>* mfont_find </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nFrame.html#gabb36d3a69526a891ce7534bda63a2687">MFrame</a> *&nbsp;</td>
          <td class="paramname"> <em>frame</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nFont.html#gace14a93b58bd3cd143f267101f805b9d">MFont</a> *&nbsp;</td>
          <td class="paramname"> <em>spec</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int *&nbsp;</td>
          <td class="paramname"> <em>score</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>max_size</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Find a font. </p>
<p>The <a class="el" href="group__m17nFont.html#ga33ec3560c126987a5a63130737849ea2" title="Find a font.">mfont_find()</a> function returns a pointer to the available font that matches best the specification <b>spec</b> on frame <b>frame</b>.</p>
<p><b>score</b>, if not NULL, must point to a place to store the score value that indicates how well the found font matches to <b>spec</b>. The smaller score means a better match. </p>

</div>
</div>
<a class="anchor" id="gace78101b0ce5a51b3d6058ce4c0f2b82"></a><!-- doxytag: member="font.c::mfont_set_encoding" ref="gace78101b0ce5a51b3d6058ce4c0f2b82" args="(MFont *font, MSymbol encoding_name, MSymbol repertory_name)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int mfont_set_encoding </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nFont.html#gace14a93b58bd3cd143f267101f805b9d">MFont</a> *&nbsp;</td>
          <td class="paramname"> <em>font</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>encoding_name</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>repertory_name</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Set encoding of a font. </p>
<p>The <a class="el" href="group__m17nFont.html#gace78101b0ce5a51b3d6058ce4c0f2b82" title="Set encoding of a font.">mfont_set_encoding()</a> function sets the encoding information of font <b>font</b>.</p>
<p><b>encoding_name</b> is a symbol representing a charset that has the same encoding as the font.</p>
<p><b>repertory_name</b> is <code>Mnil</code> or a symbol representing a charset that has the same repertory as the font. If it is <code>Mnil</code>, whether a specific character is supported by the font is asked to each font driver.</p>
<dl class="user"><dt><b>Return value:</b></dt><dd>If the operation was successful, this function returns 0. Otherwise it returns -1 and assigns an error code to the external variable <a class="el" href="group__m17nError.html#ga995a2e373cfd6a8e5eaca8686b5b0a73" title="External variable to hold error code of the m17n library.">merror_code</a>. </dd></dl>

</div>
</div>
<a class="anchor" id="gaa042ce71ba7811ef9374fd2a58e23e7f"></a><!-- doxytag: member="font.c::mfont_name" ref="gaa042ce71ba7811ef9374fd2a58e23e7f" args="(MFont *font)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">char* mfont_name </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nFont.html#gace14a93b58bd3cd143f267101f805b9d">MFont</a> *&nbsp;</td>
          <td class="paramname"> <em>font</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Create a fontname from a font. </p>
<p>This function is obsolete. Use mfont_unparse_name instead. </p>

</div>
</div>
<a class="anchor" id="ga9ac6f64a37fd3b6d59a1d7ffd675dc7e"></a><!-- doxytag: member="font.c::mfont_from_name" ref="ga9ac6f64a37fd3b6d59a1d7ffd675dc7e" args="(const char *name)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nFont.html#gace14a93b58bd3cd143f267101f805b9d">MFont</a>* mfont_from_name </td>
          <td>(</td>
          <td class="paramtype">const char *&nbsp;</td>
          <td class="paramname"> <em>name</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Create a new font from fontname. </p>
<p>This function is obsolete. Use <a class="el" href="group__m17nFont.html#ga370ca70e1fc0782bda4c47b77b17d4c6" title="Create a font by parsing a fontname.">mfont_parse_name()</a> instead. </p>

</div>
</div>
<a class="anchor" id="ga50dc0617125f859540f03f1efd8aaa14"></a><!-- doxytag: member="font.c::mfont_resize_ratio" ref="ga50dc0617125f859540f03f1efd8aaa14" args="(MFont *font)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int mfont_resize_ratio </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nFont.html#gace14a93b58bd3cd143f267101f805b9d">MFont</a> *&nbsp;</td>
          <td class="paramname"> <em>font</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get resize information of a font. </p>
<p>The <a class="el" href="group__m17nFont.html#ga50dc0617125f859540f03f1efd8aaa14" title="Get resize information of a font.">mfont_resize_ratio()</a> function lookups the m17n database &lt;font, reisize&gt; and returns a resizing ratio (in percentage) of FONT. For instance, if the return value is 150, that means that the m17n library uses an 1.5 time bigger font than a specified size. </p>

</div>
</div>
<a class="anchor" id="ga48ecb15f6d6ea751c32b7bd2802197e0"></a><!-- doxytag: member="font.c::mfont_list" ref="ga48ecb15f6d6ea751c32b7bd2802197e0" args="(MFrame *frame, MFont *font, MSymbol language, int maxnum)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a>* mfont_list </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nFrame.html#gabb36d3a69526a891ce7534bda63a2687">MFrame</a> *&nbsp;</td>
          <td class="paramname"> <em>frame</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nFont.html#gace14a93b58bd3cd143f267101f805b9d">MFont</a> *&nbsp;</td>
          <td class="paramname"> <em>font</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>language</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>maxnum</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get a list of fonts. </p>
<p>The <a class="el" href="group__m17nFont.html#ga48ecb15f6d6ea751c32b7bd2802197e0" title="Get a list of fonts.">mfont_list()</a> functions returns a list of fonts available on frame <b>frame</b>. <b>font</b>, if not NULL, limits fonts to ones that match with <b>font</b>. <b>language</b>, if not <code>Mnil</code>, limits fonts to ones that support <b>language</b>. <b>maxnum</b>, if greater than 0, limits the number of fonts.</p>
<p><b>language</b> argument exists just for backward compatibility, and the use is deprecated. Use <a class="el" href="group__m17nMtext.html#ga32374f3750874ea0142af8dac831ab25">Mlanguage</a> font property instead. If <b>font</b> already has <a class="el" href="group__m17nMtext.html#ga32374f3750874ea0142af8dac831ab25">Mlanguage</a> property, <b>language</b> is ignored.</p>
<dl class="user"><dt><b>Return value:</b></dt><dd>This function returns a plist whose keys are family names and values are pointers to the object MFont. The plist must be freed by <a class="el" href="group__m17nObject.html#ga248ba287a615a2cf3cdb99c13275453b" title="Decrement the reference count of a managed object.">m17n_object_unref()</a>. If no font is found, it returns NULL. </dd></dl>

</div>
</div>
<a class="anchor" id="ga7de45bffe64304ddddfe29f6c1a209f6"></a><!-- doxytag: member="font.c::mfont_list_family_names" ref="ga7de45bffe64304ddddfe29f6c1a209f6" args="(MFrame *frame)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a>* mfont_list_family_names </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nFrame.html#gabb36d3a69526a891ce7534bda63a2687">MFrame</a> *&nbsp;</td>
          <td class="paramname"> <em>frame</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get a list of font famiy names. </p>
<p>The <a class="el" href="group__m17nFont.html#ga7de45bffe64304ddddfe29f6c1a209f6" title="Get a list of font famiy names.">mfont_list_family_names()</a> functions returns a list of font family names available on frame <b>frame</b>.</p>
<dl class="user"><dt><b>Return value:</b></dt><dd></dd></dl>
<p>This function returns a plist whose keys are <a class="el" href="group__m17nSymbol.html#ga6592d4eb3c46fe7fb8993c252b8fedeb" title="Symbol whose name is &quot;symbol&quot;.">Msymbol</a> and values are symbols representing font family names. The elements are sorted by alphabetical order. The plist must be freed by <a class="el" href="group__m17nObject.html#ga248ba287a615a2cf3cdb99c13275453b" title="Decrement the reference count of a managed object.">m17n_object_unref()</a>. If not font is found, it returns NULL. </p>

</div>
</div>
<a class="anchor" id="gac579c026f0165e5b9b9a255995162f35"></a><!-- doxytag: member="font.c::mfont_check" ref="gac579c026f0165e5b9b9a255995162f35" args="(MFrame *frame, MFontset *fontset, MSymbol script, MSymbol language, MFont *font)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int mfont_check </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nFrame.html#gabb36d3a69526a891ce7534bda63a2687">MFrame</a> *&nbsp;</td>
          <td class="paramname"> <em>frame</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="m17n-gui_8h.html#a4c949033ca30d88fb8775caeb4134a1b">MFontset</a> *&nbsp;</td>
          <td class="paramname"> <em>fontset</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>script</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>language</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nFont.html#gace14a93b58bd3cd143f267101f805b9d">MFont</a> *&nbsp;</td>
          <td class="paramname"> <em>font</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Check the usability of a font. </p>
<p>The <a class="el" href="group__m17nFont.html#gac579c026f0165e5b9b9a255995162f35" title="Check the usability of a font.">mfont_check()</a> function checkes if <b>font</b> can be used for <b>script</b> and <b>language</b> in <b>fontset</b> on <b>frame</b>.</p>
<dl class="user"><dt><b>Return value: </b></dt><dd>If the font is usable, return 1. Otherwise return 0. </dd></dl>

</div>
</div>
<a class="anchor" id="ga33a65ab6f61909ba85dd93ee43835f0a"></a><!-- doxytag: member="font.c::mfont_match_p" ref="ga33a65ab6f61909ba85dd93ee43835f0a" args="(MFont *font, MFont *spec)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int mfont_match_p </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nFont.html#gace14a93b58bd3cd143f267101f805b9d">MFont</a> *&nbsp;</td>
          <td class="paramname"> <em>font</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nFont.html#gace14a93b58bd3cd143f267101f805b9d">MFont</a> *&nbsp;</td>
          <td class="paramname"> <em>spec</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Check is a font matches with a font spec. </p>
<p>The <a class="el" href="group__m17nFont.html#ga33a65ab6f61909ba85dd93ee43835f0a" title="Check is a font matches with a font spec.">mfont_match_p()</a> function checks if <b>font</b> matches with the font-spec <b>spec</b>.</p>
<dl class="user"><dt><b>Return value: </b></dt><dd>If the font matches, 1 is returned. Otherwise 0 is returned. </dd></dl>

</div>
</div>
<a class="anchor" id="ga209b13afe6907de28d1fad619ad354d7"></a><!-- doxytag: member="font.c::mfont_open" ref="ga209b13afe6907de28d1fad619ad354d7" args="(MFrame *frame, MFont *font)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nFont.html#gace14a93b58bd3cd143f267101f805b9d">MFont</a>* mfont_open </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nFrame.html#gabb36d3a69526a891ce7534bda63a2687">MFrame</a> *&nbsp;</td>
          <td class="paramname"> <em>frame</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nFont.html#gace14a93b58bd3cd143f267101f805b9d">MFont</a> *&nbsp;</td>
          <td class="paramname"> <em>font</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Open a font. </p>
<p>The <a class="el" href="group__m17nFont.html#ga209b13afe6907de28d1fad619ad354d7" title="Open a font.">mfont_open()</a> function opens <b>font</b> on <b>frame</b>, and returns a realized font.</p>
<dl class="user"><dt><b>Return value:</b></dt><dd>If the font was successfully opened, a realized font is returned. Otherwize NULL is returned.</dd></dl>
<dl class="user"><dt><b>See Also:</b></dt><dd><a class="el" href="group__m17nFont.html#ga52df122a9924755823427845652d1306" title="Close a font.">mfont_close()</a>. </dd></dl>

</div>
</div>
<a class="anchor" id="ga35748de25dce8fe94e765d913d7f674a"></a><!-- doxytag: member="font.c::mfont_encapsulate" ref="ga35748de25dce8fe94e765d913d7f674a" args="(MFrame *frame, MSymbol data_type, void *data)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nFont.html#gace14a93b58bd3cd143f267101f805b9d">MFont</a>* mfont_encapsulate </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nFrame.html#gabb36d3a69526a891ce7534bda63a2687">MFrame</a> *&nbsp;</td>
          <td class="paramname"> <em>frame</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>data_type</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&nbsp;</td>
          <td class="paramname"> <em>data</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Encapusulate a font. </p>
<p>The <a class="el" href="group__m17nFont.html#ga35748de25dce8fe94e765d913d7f674a" title="Encapusulate a font.">mfont_encapsulate()</a> functions realizes a font by encapusulating data <b>data</b> or type <b>data_type</b> on <b>frame</b>. Currently <b>data_tape</b> is <a class="el" href="group__m17nFont.html#gae72b66ecbfdf5a117614f76b694c5a34" title="Symbol of name &quot;fontconfig&quot;.">Mfontconfig</a> or <a class="el" href="group__m17nFont.html#ga49214e506ef5cecc1e0ef233f22e5491" title="Symbol of name &quot;freetype&quot;.">Mfreetype</a>, and <b>data</b> points to an object of FcPattern or FT_Face respectively.</p>
<dl class="user"><dt><b>Return value:</b></dt><dd>If the operation was successful, a realized font is returned. Otherwise NULL is return.</dd></dl>
<dl class="user"><dt><b>See Also:</b></dt><dd><a class="el" href="group__m17nFont.html#ga52df122a9924755823427845652d1306" title="Close a font.">mfont_close()</a>. </dd></dl>

</div>
</div>
<a class="anchor" id="ga52df122a9924755823427845652d1306"></a><!-- doxytag: member="font.c::mfont_close" ref="ga52df122a9924755823427845652d1306" args="(MFont *font)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int mfont_close </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nFont.html#gace14a93b58bd3cd143f267101f805b9d">MFont</a> *&nbsp;</td>
          <td class="paramname"> <em>font</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Close a font. </p>
<p>The <a class="el" href="group__m17nFont.html#ga52df122a9924755823427845652d1306" title="Close a font.">mfont_close()</a> function close a realized font <b>font</b>. <b>font</b> must be opened previously by <a class="el" href="group__m17nFont.html#ga209b13afe6907de28d1fad619ad354d7" title="Open a font.">mfont_open()</a> or mfont_encapsulate ().</p>
<dl class="user"><dt><b>Return value:</b></dt><dd>If the operation was successful, 0 is returned. Otherwise, -1 is returned.</dd></dl>
<dl class="user"><dt><b>See Also:</b></dt><dd><a class="el" href="group__m17nFont.html#ga209b13afe6907de28d1fad619ad354d7" title="Open a font.">mfont_open()</a>, <a class="el" href="group__m17nFont.html#ga35748de25dce8fe94e765d913d7f674a" title="Encapusulate a font.">mfont_encapsulate()</a>. </dd></dl>

</div>
</div>
<hr/><h2>Variable Documentation</h2>
<a class="anchor" id="gaaf47ff596e3d9768b214a039014b6ea5"></a><!-- doxytag: member="font.c::Mfoundry" ref="gaaf47ff596e3d9768b214a039014b6ea5" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="group__m17nFont.html#gaaf47ff596e3d9768b214a039014b6ea5">Mfoundry</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Key of font property specifying foundry. </p>
<p>The variable <a class="el" href="group__m17nFont.html#gaaf47ff596e3d9768b214a039014b6ea5" title="Key of font property specifying foundry.">Mfoundry</a> is a symbol of name <code>"foundry"</code> and is used as a key of font property and face property. The property value must be a symbol whose name is a foundry name of a font. </p>

</div>
</div>
<a class="anchor" id="gab297101760f7573ab33b846ccbda7500"></a><!-- doxytag: member="font.c::Mfamily" ref="gab297101760f7573ab33b846ccbda7500" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="group__m17nFont.html#gab297101760f7573ab33b846ccbda7500">Mfamily</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Key of font property specifying family. </p>
<p>The variable <a class="el" href="group__m17nFont.html#gab297101760f7573ab33b846ccbda7500" title="Key of font property specifying family.">Mfamily</a> is a symbol of name <code>"family"</code> and is used as a key of font property and face property. The property value must be a symbol whose name is a family name of a font. </p>

</div>
</div>
<a class="anchor" id="ga748212149a23eda2e6225ed121305308"></a><!-- doxytag: member="font.c::Mweight" ref="ga748212149a23eda2e6225ed121305308" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="group__m17nFont.html#ga748212149a23eda2e6225ed121305308">Mweight</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Key of font property specifying weight. </p>
<p>The variable <a class="el" href="group__m17nFont.html#ga748212149a23eda2e6225ed121305308" title="Key of font property specifying weight.">Mweight</a> is a symbol of name <code>"weight"</code> and is used as a key of font property and face property. The property value must be a symbol whose name is a weight name of a font (e.g "medium", "bold"). </p>

</div>
</div>
<a class="anchor" id="ga4a3a457f1c52fb783809b94366a34d86"></a><!-- doxytag: member="font.c::Mstyle" ref="ga4a3a457f1c52fb783809b94366a34d86" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="group__m17nFont.html#ga4a3a457f1c52fb783809b94366a34d86">Mstyle</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Key of font property specifying style. </p>
<p>The variable <a class="el" href="group__m17nFont.html#ga4a3a457f1c52fb783809b94366a34d86" title="Key of font property specifying style.">Mstyle</a> is a symbol of name <code>"style"</code> and is used as a key of font property and face property. The property value must be a symbol whose name is a style name of a font (e.g "r", "i", "o"). </p>

</div>
</div>
<a class="anchor" id="ga9016e01983ec22fc8e1255629e337b07"></a><!-- doxytag: member="font.c::Mstretch" ref="ga9016e01983ec22fc8e1255629e337b07" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="group__m17nFont.html#ga9016e01983ec22fc8e1255629e337b07">Mstretch</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Key of font property specifying stretch. </p>
<p>The variable <a class="el" href="group__m17nFont.html#ga9016e01983ec22fc8e1255629e337b07" title="Key of font property specifying stretch.">Mstretch</a> is a symbol of name <code>"stretch"</code> and is used as a key of font property and face property. The property value must be a symbol whose name is a stretch name of a font (e.g "normal", "condensed"). </p>

</div>
</div>
<a class="anchor" id="ga00bea74da7de4bf0b94de59f6b44d1e9"></a><!-- doxytag: member="font.c::Madstyle" ref="ga00bea74da7de4bf0b94de59f6b44d1e9" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="group__m17nFont.html#ga00bea74da7de4bf0b94de59f6b44d1e9">Madstyle</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Key of font property specifying additional style. </p>
<p>The variable <a class="el" href="group__m17nFont.html#ga00bea74da7de4bf0b94de59f6b44d1e9" title="Key of font property specifying additional style.">Madstyle</a> is a symbol of name <code>"adstyle"</code> and is used as a key of font property and face property. The property value must be a symbol whose name is an additional style name of a font (e.g "serif", "", "sans"). </p>

</div>
</div>
<a class="anchor" id="gad72f8b1c8e8eca761d4bfbc7abb56e25"></a><!-- doxytag: member="font.c::Mspacing" ref="gad72f8b1c8e8eca761d4bfbc7abb56e25" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="group__m17nFont.html#gad72f8b1c8e8eca761d4bfbc7abb56e25">Mspacing</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Key of font property specifying spacing. </p>
<p>The variable <a class="el" href="group__m17nFont.html#ga00bea74da7de4bf0b94de59f6b44d1e9" title="Key of font property specifying additional style.">Madstyle</a> is a symbol of name <code>"spacing"</code> and is used as a key of font property. The property value must be a symbol whose name specifies the spacing of a font (e.g "p" for proportional, "m" for monospaced). </p>

</div>
</div>
<a class="anchor" id="gab8c5e8d3685a530e2ae45f3b8a21ae76"></a><!-- doxytag: member="font.c::Mregistry" ref="gab8c5e8d3685a530e2ae45f3b8a21ae76" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="group__m17nFont.html#gab8c5e8d3685a530e2ae45f3b8a21ae76">Mregistry</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Key of font property specifying registry. </p>
<p>The variable <a class="el" href="group__m17nFont.html#gab8c5e8d3685a530e2ae45f3b8a21ae76" title="Key of font property specifying registry.">Mregistry</a> is a symbol of name <code>"registry"</code> and is used as a key of font property. The property value must be a symbol whose name is a registry name a font registry (e.g. "iso8859-1", "jisx0208.1983-0"). </p>

</div>
</div>
<a class="anchor" id="ga072ce0799f7766597e4d3028b70fef60"></a><!-- doxytag: member="font.c::Msize" ref="ga072ce0799f7766597e4d3028b70fef60" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="group__m17nFont.html#ga072ce0799f7766597e4d3028b70fef60">Msize</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Key of font property specifying size. </p>
<p>The variable <a class="el" href="group__m17nFont.html#ga072ce0799f7766597e4d3028b70fef60" title="Key of font property specifying size.">Msize</a> is a symbol of name <code>"size"</code> and is used as a key of font property and face property. The property value must be an integer specifying a font design size in the unit of 1/10 point (on 100 dpi display). </p>

</div>
</div>
<a class="anchor" id="ga8a615da3d1be5e23ca2d4cc02496dc97"></a><!-- doxytag: member="font.c::Motf" ref="ga8a615da3d1be5e23ca2d4cc02496dc97" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="group__m17nFont.html#ga8a615da3d1be5e23ca2d4cc02496dc97">Motf</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Key of font property specifying file name. </p>
<p>The variable <a class="el" href="group__m17nFont.html#gacfad1cf7295887580fb3d96fc5e7bf4c" title="Key of font property specifying file name.">Mfontfile</a> is a symbol of name <code>"fontfile"</code> and is used as a key of font property. The property value must be a symbol whose name is a font file name. </p>

</div>
</div>
<a class="anchor" id="gacfad1cf7295887580fb3d96fc5e7bf4c"></a><!-- doxytag: member="font.c::Mfontfile" ref="gacfad1cf7295887580fb3d96fc5e7bf4c" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="group__m17nFont.html#gacfad1cf7295887580fb3d96fc5e7bf4c">Mfontfile</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Key of font property specifying file name. </p>
<p>The variable <a class="el" href="group__m17nFont.html#gacfad1cf7295887580fb3d96fc5e7bf4c" title="Key of font property specifying file name.">Mfontfile</a> is a symbol of name <code>"fontfile"</code> and is used as a key of font property. The property value must be a symbol whose name is a font file name. </p>

</div>
</div>
<a class="anchor" id="gab4a821ee20cc5855371b31a4a0749c06"></a><!-- doxytag: member="font.c::Mresolution" ref="gab4a821ee20cc5855371b31a4a0749c06" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="group__m17nFont.html#gab4a821ee20cc5855371b31a4a0749c06">Mresolution</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Key of font property specifying resolution. </p>
<p>The variable <a class="el" href="group__m17nFont.html#gab4a821ee20cc5855371b31a4a0749c06" title="Key of font property specifying resolution.">Mresolution</a> is a symbol of name <code>"resolution"</code> and is used as a key of font property and face property. The property value must be an integer to specifying a font resolution in the unit of dots per inch (dpi). </p>

</div>
</div>
<a class="anchor" id="ga99d4189483ab20c0c91de2693c62f073"></a><!-- doxytag: member="font.c::Mmax_advance" ref="ga99d4189483ab20c0c91de2693c62f073" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="group__m17nFont.html#ga99d4189483ab20c0c91de2693c62f073">Mmax_advance</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Key of font property specifying max advance width. </p>
<p>The variable <a class="el" href="group__m17nFont.html#ga99d4189483ab20c0c91de2693c62f073" title="Key of font property specifying max advance width.">Mmax_advance</a> is a symbol of name <code>"max-advance"</code> and is used as a key of font property. The property value must be an integer specifying a font's max advance value by pixels. </p>

</div>
</div>
<a class="anchor" id="gae72b66ecbfdf5a117614f76b694c5a34"></a><!-- doxytag: member="font.c::Mfontconfig" ref="gae72b66ecbfdf5a117614f76b694c5a34" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="group__m17nFont.html#gae72b66ecbfdf5a117614f76b694c5a34">Mfontconfig</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Symbol of name "fontconfig". </p>
<p>The variable <a class="el" href="group__m17nFont.html#gae72b66ecbfdf5a117614f76b694c5a34" title="Symbol of name &quot;fontconfig&quot;.">Mfontconfig</a> is to be used as an argument of the functions <a class="el" href="group__m17nFont.html#ga370ca70e1fc0782bda4c47b77b17d4c6" title="Create a font by parsing a fontname.">mfont_parse_name()</a> and <a class="el" href="group__m17nFont.html#ga10b60c3a89c89494f2129941c28eeca2" title="Create a fontname from a font.">mfont_unparse_name()</a>. </p>

</div>
</div>
<a class="anchor" id="ga61aefaf21f63323506a84efa8dae6ded"></a><!-- doxytag: member="font.c::Mx" ref="ga61aefaf21f63323506a84efa8dae6ded" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="group__m17nFont.html#ga61aefaf21f63323506a84efa8dae6ded">Mx</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Symbol of name "x". </p>
<p>The variable <a class="el" href="group__m17nFont.html#ga61aefaf21f63323506a84efa8dae6ded" title="Symbol of name &quot;x&quot;.">Mx</a> is to be used for a value of &lt;type&gt; member of the structure <a class="el" href="structMDrawGlyph.html" title="Type of information about a glyph metric and font.">MDrawGlyph</a> to specify the type of &lt;fontp&gt; member is actually (XFontStruct *). </p>

</div>
</div>
<a class="anchor" id="ga49214e506ef5cecc1e0ef233f22e5491"></a><!-- doxytag: member="font.c::Mfreetype" ref="ga49214e506ef5cecc1e0ef233f22e5491" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="group__m17nFont.html#ga49214e506ef5cecc1e0ef233f22e5491">Mfreetype</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Symbol of name "freetype". </p>
<p>The variable <a class="el" href="group__m17nFont.html#ga49214e506ef5cecc1e0ef233f22e5491" title="Symbol of name &quot;freetype&quot;.">Mfreetype</a> is to be used for a value of &lt;type&gt; member of the structure <a class="el" href="structMDrawGlyph.html" title="Type of information about a glyph metric and font.">MDrawGlyph</a> to specify the type of &lt;fontp&gt; member is actually FT_Face. </p>

</div>
</div>
<a class="anchor" id="gaaf3238f7c80f54f971f8a5506d90c97a"></a><!-- doxytag: member="font.c::Mxft" ref="gaaf3238f7c80f54f971f8a5506d90c97a" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="group__m17nFont.html#gaaf3238f7c80f54f971f8a5506d90c97a">Mxft</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Symbol of name "xft". </p>
<p>The variable <a class="el" href="group__m17nFont.html#gaaf3238f7c80f54f971f8a5506d90c97a" title="Symbol of name &quot;xft&quot;.">Mxft</a> is to be used for a value of &lt;type&gt; member of the structure <a class="el" href="structMDrawGlyph.html" title="Type of information about a glyph metric and font.">MDrawGlyph</a> to specify the type of &lt;fontp&gt; member is actually (XftFont *). </p>

</div>
</div>
<a class="anchor" id="ga0cc7b165764f76eebb58583b06220e8a"></a><!-- doxytag: member="font.c::mfont_freetype_path" ref="ga0cc7b165764f76eebb58583b06220e8a" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a>* <a class="el" href="group__m17nFont.html#ga0cc7b165764f76eebb58583b06220e8a">mfont_freetype_path</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>List of font files and directories that contain font files. </p>
<p>The variable <code>mfont_freetype_path</code> is a plist of FreeType font files and directories that contain FreeType font files. Key of the element is <code>Mstring</code>, and the value is a string that represents a font file or a directory.</p>
<p>The macro <a class="el" href="group__m17nIntro.html#ga66879b35a1fee08b3e5966f6650c39f9" title="Initialize the m17n library.">M17N_INIT()</a> sets up this variable to contain the sub-directory "fonts" of the m17n database and the environment variable "M17NDIR". The first call of <a class="el" href="group__m17nFrame.html#ga8fa9ad4e45dff9703c471d4b243eb674" title="Create a new frame.">mframe()</a> creates the internal list of the actually available fonts from this variable. Thus, an application program, if necessary, must modify the variable before calling <a class="el" href="group__m17nFrame.html#ga8fa9ad4e45dff9703c471d4b243eb674" title="Create a new frame.">mframe()</a>. If it is going to add a new element, value must be a string that can be safely freed.</p>
<p>If the m17n library is not configured to use the FreeType library, this variable is not used. </p>

</div>
</div>
</div>
<!--- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&nbsp;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&nbsp;</span>Data Structures</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&nbsp;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&nbsp;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&nbsp;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&nbsp;</span>Typedefs</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&nbsp;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&nbsp;</span>Enumerator</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&nbsp;</span>Defines</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<hr>

<ADDRESS>
<a href="http://www.m17n.org/m17n-lib-en/index.html" target="mulewindow"><img src="parrot.png" align=bottom alt="m17n-lib Home" border=0></a>
</ADDRESS>
</body>
</HTML>

<!-- Copyright information

Copyright (C) 2001 Information-technology Promotion Agency (IPA)
Copyright (C) 2001-2011
  National Institute of Advanced Industrial Science and Technology (AIST)

This file is part of the m17n library documentation.

Permission is granted to copy, distribute and/or modify this document
under the terms of the GNU Free Documentation License, Version 1.2 or
any later version published by the Free Software Foundation; with no
Invariant Section, no Front-Cover Texts,
and no Back-Cover Texts.  A copy of the license is included in the
appendix entitled "GNU Free Documentation License".
-->
